<!DOCTYPE html>
<html lang="en">

<head>
    <title>Xem chi tiết người dùng</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron">
        <h1>Chi tiết user</h1>
        <div class=" row mb-2">
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">First Name</label>
            </div>
            <div class="col-sm-10">
                <input id="first-name" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Last name</label>
            </div>
            <div class="col-sm-10">
                <input id="last-name" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Subject</label>
            </div>
            <div class="col-sm-10">
                <input id="subject" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Country</label>
            </div>
            <div class="col-sm-10">
                <select id="country" class="form-control mb-2" name="" id="">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Customer Type</label>
            </div>
            <div class="col-sm-10">
                <select id="cus-type" class="form-control mb-2" name="" id="">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Register status</label>
            </div>
            <div class="col-sm-10">
                <select id="reg-status" class="form-control mb-2" name="" id="">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <!--hai nut  -->
        <div class="row">
            <div class="col-sm-6">
                <button id="btn-update" class="btn btn-success form-control">Update user</button>
            </div>
            <div class="col-sm-6">
                <button id="btn-huy-bo" class="btn btn-success form-control">Hủy bỏ</button>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gId = "";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
    });
    $("#btn-update").click(getUpDateUser);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict"
        // b1 . lấy id từ herl
        //B1: Lấy địa chỉ URL của trang thông qua window.location.href
        var vUrlString = window.location.href; //đường đẫn gọi đến trang
        //B2: Tạo đối tượng URL để có thể tìm kiếm các thông tin
        var vUrl = new URL(vUrlString); // tham số đầu vào là địa chỉ URL cần phân tích
        //B3: Lấy giá trị của 1 tham số truyền qua địa chỉ URL sau khi đã phân tích:
        // get parameters
        var vId = vUrl.searchParams.get("id");
        gId = vId;
        console.log(vId);
        // b3 goi api 
        getCallApiLoadUser(vId);
        // show ra input 
        // Cách lấy dữ liệu truyền qua queryString:
    }
    // khai báo nút uppdate 
    function getUpDateUser() {
        console.log("nut update ");
        // khai báo object lưu trữ 
        var vObjectUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: ""
        }
        // b1 collect data 
        getCollectData(vObjectUser);
        // b2 validate data 
        var vResult = getValidateData(vObjectUser);
        // b3 get api
        if (vResult) {
            console.log("kiểm tra dữ liệu đạt yêu cầu ");
            getCallApiUpdateUser(vObjectUser);

        }
        // b4 show wed
       
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // gọi api update data 
    function getCallApiUpdateUser(paramObject) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + gId,
            type: "PUT",
            contentType: "application/json",
            async: true,
            data: JSON.stringify(paramObject),
            success: getSuccessUpdateData,
            error: getErrorUpdateUser
        });
    }
    // khai bóa hàm khi xảy ra lỗi 
    function getErrorUpdateUser(paramError) {
        console.log(paramError.status);
        console.log("cập nhập thông tin không thành công ");
        window.location.href = "task32-50.html";
    }
    // khai báo hàm success update user
    function getSuccessUpdateData(paramRes) {
        alert("Thông báo : đã cập nhập thông tin thành công ")
        console.log(paramRes);
        window.location.href = "task32-50.html";
    }
    // gọi api cho onpage loading
    function getCallApiLoadUser(paramId) {
        "use strict"
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramId,
            type: "GET",
            dataType: "json",
            async: true,
            success: getLoadBody,
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    // success api user load body
    // dựa vào object nhận được đổ dữ liệu lên form 
    function getLoadBody(paramRes) {
        "use strict"
        console.log(paramRes);
        // đổ dữ liệu lên form
        $("#first-name").val(paramRes.firstname);
        $("#last-name").val(paramRes.lastname);
        $("#country").val(paramRes.country);
        $("#subject").val(paramRes.subject);
        $("#cus-type").val(paramRes.customerType);
        $("#reg-status").val(paramRes.registerStatus);
    }
    // khai  báo hàm thu thập dữ liệu
    function getCollectData(paramObject) {
        paramObject.firstname = $("#first-name").val().trim();
        paramObject.lastname = $("#last-name").val().trim();
        paramObject.country = $("#country").val().trim();
        paramObject.subject = $("#subject").val();
        paramObject.customerType = $("#cus-type").val();
        paramObject.registerStatus = $("#reg-status").val();
    }
    // khai báo hàm kiểm tra dữ liệu 
    function getValidateData(paramObject) {
        if (paramObject.firstname == "") {
            alert("firstname không được để trống ");
            return false;
        }
        if (paramObject.lastname == "") {
            alert("lastname không được để trống ");
            return false;
        }
        if (paramObject.country == "") {
            alert("country không được để trống ");
            return false;
        }
        if (paramObject.subject == null) {
            alert("subject không được để trống ");
            return false;
        }
        if (paramObject.customerType == null) {
            alert("customerType không được để trống ");
            return false;
        }
        if (paramObject.registerStatus == null) {
            alert("Register status không được để trống ");
            return false;
        }
        return true;
    }
</script>

</html>